//
// Copyright 2020 FoxyUtils ehf. All rights reserved.
//
// This is a commercial product and requires a license to operate.
// A trial license can be obtained at https://unidoc.io
//
// DO NOT EDIT: generated by unitwist Go source code obfuscator.
//
// Use of this source code is governed by the UniDoc End User License Agreement
// terms that can be accessed at https://unidoc.io/eula/

// Package fdf provides support for loading form field data from Form Field Data (FDF) files.
package fdf ;import (_bb "bufio";_bcg "bytes";_bc "encoding/hex";_fb "errors";_e "fmt";_cd "github.com/unidoc/unipdf/v3/common";_cb "github.com/unidoc/unipdf/v3/core";_fef "io";_ee "os";_b "regexp";_bf "sort";_fe "strconv";_c "strings";);

// Data represents forms data format (FDF) file data.
type Data struct{_cdd *_cb .PdfObjectDictionary ;_ca *_cb .PdfObjectArray ;};var _bbc =_b .MustCompile ("\u0025\u0025\u0045O\u0046");

// FieldValues implements interface model.FieldValueProvider.
// Returns a map of field names to values (PdfObjects).
func (fdf *Data )FieldValues ()(map[string ]_cb .PdfObject ,error ){_cbf ,_gd :=fdf .FieldDictionaries ();if _gd !=nil {return nil ,_gd ;};var _ag []string ;for _ab :=range _cbf {_ag =append (_ag ,_ab );};_bf .Strings (_ag );_ed :=map[string ]_cb .PdfObject {};
for _ ,_de :=range _ag {_gg :=_cbf [_de ];_da :=_cb .TraceToDirectObject (_gg .Get ("\u0056"));_ed [_de ]=_da ;};return _ed ,nil ;};func _dgg (_add string )(*fdfParser ,error ){_cfg :=fdfParser {};_gda :=[]byte (_add );_baf :=_bcg .NewReader (_gda );_cfg ._bbe =_baf ;
_cfg ._cdeg =map[int64 ]_cb .PdfObject {};_abgb :=_bb .NewReader (_baf );_cfg ._bfb =_abgb ;_cfg ._dg =int64 (len (_add ));return &_cfg ,_cfg .parse ();};func (_cab *fdfParser )skipSpaces ()(int ,error ){_eea :=0;for {_fdf ,_afb :=_cab ._bfb .ReadByte ();
if _afb !=nil {return 0,_afb ;};if _cb .IsWhiteSpace (_fdf ){_eea ++;}else {_cab ._bfb .UnreadByte ();break ;};};return _eea ,nil ;};func _abgg (_edc _fef .ReadSeeker )(*fdfParser ,error ){_cagb :=&fdfParser {};_cagb ._bbe =_edc ;_cagb ._cdeg =map[int64 ]_cb .PdfObject {};
_ccf ,_gab ,_eeb :=_cagb .parseFdfVersion ();if _eeb !=nil {_cd .Log .Error ("U\u006e\u0061\u0062\u006c\u0065\u0020t\u006f\u0020\u0070\u0061\u0072\u0073\u0065\u0020\u0076e\u0072\u0073\u0069o\u006e:\u0020\u0025\u0076",_eeb );return nil ,_eeb ;};_cagb ._gba =_ccf ;
_cagb ._agd =_gab ;_eeb =_cagb .parse ();return _cagb ,_eeb ;};func (_gga *fdfParser )readComment ()(string ,error ){var _dge _bcg .Buffer ;_ ,_ea :=_gga .skipSpaces ();if _ea !=nil {return _dge .String (),_ea ;};_agc :=true ;for {_gfd ,_cc :=_gga ._bfb .Peek (1);
if _cc !=nil {_cd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_cc .Error ());return _dge .String (),_cc ;};if _agc &&_gfd [0]!='%'{return _dge .String (),_fb .New ("c\u006f\u006d\u006d\u0065\u006e\u0074 \u0073\u0068\u006f\u0075\u006c\u0064\u0020\u0073\u0074a\u0072\u0074\u0020w\u0069t\u0068\u0020\u0025");
};_agc =false ;if (_gfd [0]!='\r')&&(_gfd [0]!='\n'){_gcc ,_ :=_gga ._bfb .ReadByte ();_dge .WriteByte (_gcc );}else {break ;};};return _dge .String (),nil ;};func (_cde *fdfParser )getFileOffset ()int64 {_gdc ,_ :=_cde ._bbe .Seek (0,_fef .SeekCurrent );
_gdc -=int64 (_cde ._bfb .Buffered ());return _gdc ;};func (_bcc *fdfParser )parseHexString ()(*_cb .PdfObjectString ,error ){_bcc ._bfb .ReadByte ();var _edef _bcg .Buffer ;for {_fdg ,_cddg :=_bcc ._bfb .Peek (1);if _cddg !=nil {return _cb .MakeHexString (""),_cddg ;
};if _fdg [0]=='>'{_bcc ._bfb .ReadByte ();break ;};_ebe ,_ :=_bcc ._bfb .ReadByte ();if !_cb .IsWhiteSpace (_ebe ){_edef .WriteByte (_ebe );};};if _edef .Len ()%2==1{_edef .WriteRune ('0');};_bcd ,_dcd :=_bc .DecodeString (_edef .String ());if _dcd !=nil {_cd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020\u0050\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0068\u0065\u0078\u0020\u0073\u0074r\u0069\u006e\u0067\u003a\u0020\u0027\u0025\u0073\u0027 \u002d\u0020\u0072\u0065\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u0061n\u0020\u0065\u006d\u0070\u0074\u0079 \u0073\u0074\u0072i\u006e\u0067",_edef .String ());
return _cb .MakeHexString (""),nil ;};return _cb .MakeHexString (string (_bcd )),nil ;};func (_gaf *fdfParser )parseNull ()(_cb .PdfObjectNull ,error ){_ ,_bdf :=_gaf ._bfb .Discard (4);return _cb .PdfObjectNull {},_bdf ;};var _gbb =_b .MustCompile ("\u0028\u005c\u0064\u002b)\\\u0073\u002b\u0028\u005c\u0064\u002b\u0029\u005c\u0073\u002b\u006f\u0062\u006a");


// FieldDictionaries returns a map of field names to field dictionaries.
func (fdf *Data )FieldDictionaries ()(map[string ]*_cb .PdfObjectDictionary ,error ){_eg :=map[string ]*_cb .PdfObjectDictionary {};for _ff :=0;_ff < fdf ._ca .Len ();_ff ++{_af ,_aa :=_cb .GetDict (fdf ._ca .Get (_ff ));if _aa {_gb ,_ :=_cb .GetString (_af .Get ("\u0054"));
if _gb !=nil {_eg [_gb .Str ()]=_af ;};};};return _eg ,nil ;};func (_feg *fdfParser )setFileOffset (_dfd int64 ){_feg ._bbe .Seek (_dfd ,_fef .SeekStart );_feg ._bfb =_bb .NewReader (_feg ._bbe );};var _dba =_b .MustCompile ("\u005e\u005b\u005c\u002b\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d9\u002e\u005d\u002b\u0029");


// Load loads FDF form data from `r`.
func Load (r _fef .ReadSeeker )(*Data ,error ){_fg ,_d :=_abgg (r );if _d !=nil {return nil ,_d ;};_g ,_d :=_fg .Root ();if _d !=nil {return nil ,_d ;};_gc ,_gcg :=_cb .GetArray (_g .Get ("\u0046\u0069\u0065\u006c\u0064\u0073"));if !_gcg {return nil ,_fb .New ("\u0066\u0069\u0065\u006c\u0064\u0073\u0020\u006d\u0069s\u0073\u0069\u006e\u0067");
};return &Data {_ca :_gc ,_cdd :_g },nil ;};func (_fae *fdfParser )parseFdfVersion ()(int ,int ,error ){_fae ._bbe .Seek (0,_fef .SeekStart );_bcf :=20;_cbe :=make ([]byte ,_bcf );_fae ._bbe .Read (_cbe );_cae :=_afg .FindStringSubmatch (string (_cbe ));
if len (_cae )< 3{_gge ,_gde ,_agdc :=_fae .seekFdfVersionTopDown ();if _agdc !=nil {_cd .Log .Debug ("F\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065\u0063\u006f\u0076\u0065\u0072\u0079\u0020\u002d\u0020\u0075n\u0061\u0062\u006c\u0065\u0020\u0074\u006f\u0020\u0066\u0069nd\u0020\u0076\u0065r\u0073i\u006f\u006e");
return 0,0,_agdc ;};return _gge ,_gde ,nil ;};_eeag ,_aaa :=_fe .Atoi (_cae [1]);if _aaa !=nil {return 0,0,_aaa ;};_dee ,_aaa :=_fe .Atoi (_cae [2]);if _aaa !=nil {return 0,0,_aaa ;};_cd .Log .Debug ("\u0046\u0064\u0066\u0020\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020%\u0064\u002e\u0025\u0064",_eeag ,_dee );
return _eeag ,_dee ,nil ;};func (_bfd *fdfParser )trace (_caad _cb .PdfObject )_cb .PdfObject {switch _bbd :=_caad .(type ){case *_cb .PdfObjectReference :_bddf ,_dbg :=_bfd ._cdeg [_bbd .ObjectNumber ].(*_cb .PdfIndirectObject );if _dbg {return _bddf .PdfObject ;
};_cd .Log .Debug ("\u0054\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");return nil ;case *_cb .PdfIndirectObject :return _bbd .PdfObject ;};return _caad ;};func (_bdeg *fdfParser )parseName ()(_cb .PdfObjectName ,error ){var _fdff _bcg .Buffer ;
_bae :=false ;for {_gdd ,_fgf :=_bdeg ._bfb .Peek (1);if _fgf ==_fef .EOF {break ;};if _fgf !=nil {return _cb .PdfObjectName (_fdff .String ()),_fgf ;};if !_bae {if _gdd [0]=='/'{_bae =true ;_bdeg ._bfb .ReadByte ();}else if _gdd [0]=='%'{_bdeg .readComment ();
_bdeg .skipSpaces ();}else {_cd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u0020N\u0061\u006d\u0065\u0020\u0073\u0074\u0061\u0072\u0074\u0069\u006e\u0067\u0020w\u0069\u0074\u0068\u0020\u0025\u0073\u0020(\u0025\u0020\u0078\u0029",_gdd ,_gdd );return _cb .PdfObjectName (_fdff .String ()),_e .Errorf ("\u0069n\u0076a\u006c\u0069\u0064\u0020\u006ea\u006d\u0065:\u0020\u0028\u0025\u0063\u0029",_gdd [0]);
};}else {if _cb .IsWhiteSpace (_gdd [0]){break ;}else if (_gdd [0]=='/')||(_gdd [0]=='[')||(_gdd [0]=='(')||(_gdd [0]==']')||(_gdd [0]=='<')||(_gdd [0]=='>'){break ;}else if _gdd [0]=='#'{_dd ,_bgg :=_bdeg ._bfb .Peek (3);if _bgg !=nil {return _cb .PdfObjectName (_fdff .String ()),_bgg ;
};_bdeg ._bfb .Discard (3);_gef ,_bgg :=_bc .DecodeString (string (_dd [1:3]));if _bgg !=nil {return _cb .PdfObjectName (_fdff .String ()),_bgg ;};_fdff .Write (_gef );}else {_agde ,_ :=_bdeg ._bfb .ReadByte ();_fdff .WriteByte (_agde );};};};return _cb .PdfObjectName (_fdff .String ()),nil ;
};func (_aef *fdfParser )readTextLine ()(string ,error ){var _eed _bcg .Buffer ;for {_bg ,_ge :=_aef ._bfb .Peek (1);if _ge !=nil {_cd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_ge .Error ());return _eed .String (),_ge ;};if (_bg [0]!='\r')&&(_bg [0]!='\n'){_gbg ,_ :=_aef ._bfb .ReadByte ();
_eed .WriteByte (_gbg );}else {break ;};};return _eed .String (),nil ;};func (_aaf *fdfParser )parseIndirectObject ()(_cb .PdfObject ,error ){_afd :=_cb .PdfIndirectObject {};_cd .Log .Trace ("\u002dR\u0065a\u0064\u0020\u0069\u006e\u0064i\u0072\u0065c\u0074\u0020\u006f\u0062\u006a");
_cbcc ,_eac :=_aaf ._bfb .Peek (20);if _eac !=nil {_cd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");
return &_afd ,_eac ;};_cd .Log .Trace ("\u0028\u0069\u006edi\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0020\u0070\u0065\u0065\u006b\u0020\u0022\u0025\u0073\u0022",string (_cbcc ));_abg :=_gbb .FindStringSubmatchIndex (string (_cbcc ));if len (_abg )< 6{_cd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_cbcc ));
return &_afd ,_fb .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_aaf ._bfb .Discard (_abg [0]);_cd .Log .Trace ("O\u0066\u0066\u0073\u0065\u0074\u0073\u0020\u0025\u0020\u0064",_abg );_age :=_abg [1]-_abg [0];_bdb :=make ([]byte ,_age );_ ,_eac =_aaf .readAtLeast (_bdb ,_age );if _eac !=nil {_cd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0075\u006e\u0061\u0062l\u0065\u0020\u0074\u006f\u0020\u0072\u0065\u0061\u0064\u0020-\u0020\u0025\u0073",_eac );
return nil ,_eac ;};_cd .Log .Trace ("\u0074\u0065\u0078t\u006c\u0069\u006e\u0065\u003a\u0020\u0025\u0073",_bdb );_cga :=_gbb .FindStringSubmatch (string (_bdb ));if len (_cga )< 3{_cd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_bdb ));
return &_afd ,_fb .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_ef ,_ :=_fe .Atoi (_cga [1]);_dcdd ,_ :=_fe .Atoi (_cga [2]);_afd .ObjectNumber =int64 (_ef );_afd .GenerationNumber =int64 (_dcdd );for {_agec ,_gdf :=_aaf ._bfb .Peek (2);if _gdf !=nil {return &_afd ,_gdf ;};_cd .Log .Trace ("I\u006ed\u002e\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_agec ),string (_agec ));
if _cb .IsWhiteSpace (_agec [0]){_aaf .skipSpaces ();}else if _agec [0]=='%'{_aaf .skipComments ();}else if (_agec [0]=='<')&&(_agec [1]=='<'){_cd .Log .Trace ("\u0043\u0061\u006c\u006c\u0020\u0050\u0061\u0072\u0073e\u0044\u0069\u0063\u0074");_afd .PdfObject ,_gdf =_aaf .parseDict ();
_cd .Log .Trace ("\u0045\u004f\u0046\u0020Ca\u006c\u006c\u0020\u0050\u0061\u0072\u0073\u0065\u0044\u0069\u0063\u0074\u003a\u0020%\u0076",_gdf );if _gdf !=nil {return &_afd ,_gdf ;};_cd .Log .Trace ("\u0050\u0061\u0072\u0073\u0065\u0064\u0020\u0064\u0069\u0063t\u0069\u006f\u006e\u0061\u0072\u0079\u002e.\u002e\u0020\u0066\u0069\u006e\u0069\u0073\u0068\u0065\u0064\u002e");
}else if (_agec [0]=='/')||(_agec [0]=='(')||(_agec [0]=='[')||(_agec [0]=='<'){_afd .PdfObject ,_gdf =_aaf .parseObject ();if _gdf !=nil {return &_afd ,_gdf ;};_cd .Log .Trace ("P\u0061\u0072\u0073\u0065\u0064\u0020o\u0062\u006a\u0065\u0063\u0074\u0020\u002e\u002e\u002e \u0066\u0069\u006ei\u0073h\u0065\u0064\u002e");
}else {if _agec [0]=='e'{_dcb ,_bbgf :=_aaf .readTextLine ();if _bbgf !=nil {return nil ,_bbgf ;};if len (_dcb )>=6&&_dcb [0:6]=="\u0065\u006e\u0064\u006f\u0062\u006a"{break ;};}else if _agec [0]=='s'{_agec ,_ =_aaf ._bfb .Peek (10);if string (_agec [:6])=="\u0073\u0074\u0072\u0065\u0061\u006d"{_cfc :=6;
if len (_agec )> 6{if _cb .IsWhiteSpace (_agec [_cfc ])&&_agec [_cfc ]!='\r'&&_agec [_cfc ]!='\n'{_cd .Log .Debug ("\u004e\u006fn\u002d\u0063\u006f\u006e\u0066\u006f\u0072\u006d\u0061\u006e\u0074\u0020\u0046\u0044\u0046\u0020\u006e\u006f\u0074 \u0065\u006e\u0064\u0069\u006e\u0067 \u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006c\u0069\u006e\u0065\u0020\u0070\u0072o\u0070\u0065r\u006c\u0079\u0020\u0077i\u0074\u0068\u0020\u0045\u004fL\u0020\u006d\u0061\u0072\u006b\u0065\u0072");
_cfc ++;};if _agec [_cfc ]=='\r'{_cfc ++;if _agec [_cfc ]=='\n'{_cfc ++;};}else if _agec [_cfc ]=='\n'{_cfc ++;};};_aaf ._bfb .Discard (_cfc );_ddb ,_cag :=_afd .PdfObject .(*_cb .PdfObjectDictionary );if !_cag {return nil ,_fb .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006di\u0073s\u0069\u006e\u0067\u0020\u0064\u0069\u0063\u0074\u0069\u006f\u006e\u0061\u0072\u0079");
};_cd .Log .Trace ("\u0053\u0074\u0072\u0065\u0061\u006d\u0020\u0064\u0069c\u0074\u0020\u0025\u0073",_ddb );_dbbe ,_gaa :=_ddb .Get ("\u004c\u0065\u006e\u0067\u0074\u0068").(*_cb .PdfObjectInteger );if !_gaa {return nil ,_fb .New ("\u0073\u0074re\u0061\u006d\u0020l\u0065\u006e\u0067\u0074h n\u0065ed\u0073\u0020\u0074\u006f\u0020\u0062\u0065 a\u006e\u0020\u0069\u006e\u0074\u0065\u0067e\u0072");
};_fed :=*_dbbe ;if _fed < 0{return nil ,_fb .New ("\u0073\u0074\u0072\u0065\u0061\u006d\u0020\u006e\u0065\u0065\u0064\u0073\u0020\u0074\u006f \u0062e\u0020\u006c\u006f\u006e\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0030");};if int64 (_fed )> _aaf ._dg {_cd .Log .Debug ("\u0045\u0052R\u004f\u0052\u003a\u0020\u0053t\u0072\u0065\u0061\u006d\u0020l\u0065\u006e\u0067\u0074\u0068\u0020\u0063\u0061\u006e\u006e\u006f\u0074\u0020\u0062\u0065\u0020\u006c\u0061\u0072\u0067\u0065\u0072\u0020\u0074\u0068\u0061\u006e\u0020\u0066\u0069\u006c\u0065\u0020\u0073\u0069\u007a\u0065");
return nil ,_fb .New ("\u0069n\u0076\u0061l\u0069\u0064\u0020\u0073t\u0072\u0065\u0061m\u0020\u006c\u0065\u006e\u0067\u0074\u0068\u002c\u0020la\u0072\u0067\u0065r\u0020\u0074h\u0061\u006e\u0020\u0066\u0069\u006ce\u0020\u0073i\u007a\u0065");};_aebb :=make ([]byte ,_fed );
_ ,_gdf =_aaf .readAtLeast (_aebb ,int (_fed ));if _gdf !=nil {_cd .Log .Debug ("E\u0052\u0052\u004f\u0052 s\u0074r\u0065\u0061\u006d\u0020\u0028%\u0064\u0029\u003a\u0020\u0025\u0058",len (_aebb ),_aebb );_cd .Log .Debug ("\u0045R\u0052\u004f\u0052\u003a\u0020\u0025v",_gdf );
return nil ,_gdf ;};_fcb :=_cb .PdfObjectStream {};_fcb .Stream =_aebb ;_fcb .PdfObjectDictionary =_afd .PdfObject .(*_cb .PdfObjectDictionary );_fcb .ObjectNumber =_afd .ObjectNumber ;_fcb .GenerationNumber =_afd .GenerationNumber ;_aaf .skipSpaces ();
_aaf ._bfb .Discard (9);_aaf .skipSpaces ();return &_fcb ,nil ;};};_afd .PdfObject ,_gdf =_aaf .parseObject ();return &_afd ,_gdf ;};};_cd .Log .Trace ("\u0052\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0021");
return &_afd ,nil ;};

// Root returns the Root of the FDF document.
func (_ac *fdfParser )Root ()(*_cb .PdfObjectDictionary ,error ){if _ac ._ec !=nil {if _ccg ,_aeg :=_ac .trace (_ac ._ec .Get ("\u0052\u006f\u006f\u0074")).(*_cb .PdfObjectDictionary );_aeg {if _bbcc ,_dec :=_ac .trace (_ccg .Get ("\u0046\u0044\u0046")).(*_cb .PdfObjectDictionary );
_dec {return _bbcc ,nil ;};};};var _baac []int64 ;for _aca :=range _ac ._cdeg {_baac =append (_baac ,_aca );};_bf .Slice (_baac ,func (_gcce ,_dbf int )bool {return _baac [_gcce ]< _baac [_dbf ]});for _ ,_agg :=range _baac {_bdd :=_ac ._cdeg [_agg ];if _ffg ,_aaac :=_ac .trace (_bdd ).(*_cb .PdfObjectDictionary );
_aaac {if _efa ,_ggb :=_ac .trace (_ffg .Get ("\u0046\u0044\u0046")).(*_cb .PdfObjectDictionary );_ggb {return _efa ,nil ;};};};return nil ,_fb .New ("\u0046\u0044\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");};func _gac (_fege string )(_cb .PdfObjectReference ,error ){_eaa :=_cb .PdfObjectReference {};
_ffcb :=_bfa .FindStringSubmatch (_fege );if len (_ffcb )< 3{_cd .Log .Debug ("\u0045\u0072\u0072or\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0072\u0065\u0066\u0065\u0072\u0065\u006e\u0063\u0065");return _eaa ,_fb .New ("\u0075n\u0061\u0062\u006c\u0065 \u0074\u006f\u0020\u0070\u0061r\u0073e\u0020r\u0065\u0066\u0065\u0072\u0065\u006e\u0063e");
};_bfg ,_agf :=_fe .Atoi (_ffcb [1]);if _agf !=nil {_cd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0070a\u0072\u0073\u0069n\u0067\u0020\u006fb\u006a\u0065c\u0074\u0020\u006e\u0075\u006d\u0062e\u0072 '\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u006e\u0075\u006d\u0020\u003d\u0020\u0030",_ffcb [1]);
return _eaa ,nil ;};_eaa .ObjectNumber =int64 (_bfg );_daca ,_agf :=_fe .Atoi (_ffcb [2]);if _agf !=nil {_cd .Log .Debug ("\u0045\u0072r\u006f\u0072\u0020\u0070\u0061r\u0073\u0069\u006e\u0067\u0020g\u0065\u006e\u0065\u0072\u0061\u0074\u0069\u006f\u006e\u0020\u006e\u0075\u006d\u0062\u0065\u0072\u0020\u0027\u0025\u0073\u0027\u0020\u002d\u0020\u0055\u0073\u0069\u006e\u0067\u0020\u0067\u0065\u006e\u0020\u003d\u0020\u0030",_ffcb [2]);
return _eaa ,nil ;};_eaa .GenerationNumber =int64 (_daca );return _eaa ,nil ;};func (_aac *fdfParser )skipComments ()error {if _ ,_gf :=_aac .skipSpaces ();_gf !=nil {return _gf ;};_ggg :=true ;for {_ce ,_eb :=_aac ._bfb .Peek (1);if _eb !=nil {_cd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u0020\u0025\u0073",_eb .Error ());
return _eb ;};if _ggg &&_ce [0]!='%'{return nil ;};_ggg =false ;if (_ce [0]!='\r')&&(_ce [0]!='\n'){_aac ._bfb .ReadByte ();}else {break ;};};return _aac .skipComments ();};func (_ffca *fdfParser )seekFdfVersionTopDown ()(int ,int ,error ){_ffca ._bbe .Seek (0,_fef .SeekStart );
_ffca ._bfb =_bb .NewReader (_ffca ._bbe );_abggf :=20;_fdgf :=make ([]byte ,_abggf );for {_ecef ,_geba :=_ffca ._bfb .ReadByte ();if _geba !=nil {if _geba ==_fef .EOF {break ;}else {return 0,0,_geba ;};};if _cb .IsDecimalDigit (_ecef )&&_fdgf [_abggf -1]=='.'&&_cb .IsDecimalDigit (_fdgf [_abggf -2])&&_fdgf [_abggf -3]=='-'&&_fdgf [_abggf -4]=='F'&&_fdgf [_abggf -5]=='D'&&_fdgf [_abggf -6]=='P'{_bdc :=int (_fdgf [_abggf -2]-'0');
_aee :=int (_ecef -'0');return _bdc ,_aee ,nil ;};_fdgf =append (_fdgf [1:_abggf ],_ecef );};return 0,0,_fb .New ("\u0076\u0065\u0072\u0073\u0069\u006f\u006e\u0020\u006e\u006f\u0074\u0020f\u006f\u0075\u006e\u0064");};func (_aea *fdfParser )parseDict ()(*_cb .PdfObjectDictionary ,error ){_cd .Log .Trace ("\u0052\u0065\u0061\u0064\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020D\u0069\u0063\u0074\u0021");
_dbd :=_cb .MakeDict ();_gbbc ,_ :=_aea ._bfb .ReadByte ();if _gbbc !='<'{return nil ,_fb .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");};_gbbc ,_ =_aea ._bfb .ReadByte ();if _gbbc !='<'{return nil ,_fb .New ("\u0069\u006e\u0076a\u006c\u0069\u0064\u0020\u0064\u0069\u0063\u0074");
};for {_aea .skipSpaces ();_aea .skipComments ();_edg ,_egg :=_aea ._bfb .Peek (2);if _egg !=nil {return nil ,_egg ;};_cd .Log .Trace ("D\u0069c\u0074\u0020\u0070\u0065\u0065\u006b\u003a\u0020%\u0073\u0020\u0028\u0025 x\u0029\u0021",string (_edg ),string (_edg ));
if (_edg [0]=='>')&&(_edg [1]=='>'){_cd .Log .Trace ("\u0045\u004f\u0046\u0020\u0064\u0069\u0063\u0074\u0069o\u006e\u0061\u0072\u0079");_aea ._bfb .ReadByte ();_aea ._bfb .ReadByte ();break ;};_cd .Log .Trace ("\u0050a\u0072s\u0065\u0020\u0074\u0068\u0065\u0020\u006e\u0061\u006d\u0065\u0021");
_caab ,_egg :=_aea .parseName ();_cd .Log .Trace ("\u004be\u0079\u003a\u0020\u0025\u0073",_caab );if _egg !=nil {_cd .Log .Debug ("E\u0052\u0052\u004f\u0052\u0020\u0052e\u0074\u0075\u0072\u006e\u0069\u006e\u0067\u0020\u006ea\u006d\u0065\u0020e\u0072r\u0020\u0025\u0073",_egg );
return nil ,_egg ;};if len (_caab )> 4&&_caab [len (_caab )-4:]=="\u006e\u0075\u006c\u006c"{_cf :=_caab [0:len (_caab )-4];_cd .Log .Debug ("\u0054\u0061\u006b\u0069n\u0067\u0020\u0063\u0061\u0072\u0065\u0020\u006f\u0066\u0020n\u0075l\u006c\u0020\u0062\u0075\u0067\u0020\u0028%\u0073\u0029",_caab );
_cd .Log .Debug ("\u004e\u0065\u0077\u0020ke\u0079\u0020\u0022\u0025\u0073\u0022\u0020\u003d\u0020\u006e\u0075\u006c\u006c",_cf );_aea .skipSpaces ();_fdd ,_ :=_aea ._bfb .Peek (1);if _fdd [0]=='/'{_dbd .Set (_cf ,_cb .MakeNull ());continue ;};};_aea .skipSpaces ();
_eba ,_egg :=_aea .parseObject ();if _egg !=nil {return nil ,_egg ;};_dbd .Set (_caab ,_eba );_cd .Log .Trace ("\u0064\u0069\u0063\u0074\u005b\u0025\u0073\u005d\u0020\u003d\u0020\u0025\u0073",_caab ,_eba .String ());};_cd .Log .Trace ("\u0072\u0065\u0074\u0075rn\u0069\u006e\u0067\u0020\u0046\u0044\u0046\u0020\u0044\u0069\u0063\u0074\u0021");
return _dbd ,nil ;};var _afg =_b .MustCompile ("\u0025F\u0044F\u002d\u0028\u005c\u0064\u0029\u005c\u002e\u0028\u005c\u0064\u0029");

// LoadFromPath loads FDF form data from file path `fdfPath`.
func LoadFromPath (fdfPath string )(*Data ,error ){_db ,_bd :=_ee .Open (fdfPath );if _bd !=nil {return nil ,_bd ;};defer _db .Close ();return Load (_db );};var _bfa =_b .MustCompile ("^\u005c\u0073\u002a\u0028\\d\u002b)\u005c\u0073\u002b\u0028\u005cd\u002b\u0029\u005c\u0073\u002b\u0052");
func (_dcf *fdfParser )parseObject ()(_cb .PdfObject ,error ){_cd .Log .Trace ("\u0052e\u0061d\u0020\u0064\u0069\u0072\u0065c\u0074\u0020o\u0062\u006a\u0065\u0063\u0074");_dcf .skipSpaces ();for {_cbg ,_cdc :=_dcf ._bfb .Peek (2);if _cdc !=nil {return nil ,_cdc ;
};_cd .Log .Trace ("\u0050e\u0065k\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u003a\u0020\u0025\u0073",string (_cbg ));if _cbg [0]=='/'{_geb ,_aebe :=_dcf .parseName ();_cd .Log .Trace ("\u002d\u003e\u004ea\u006d\u0065\u003a\u0020\u0027\u0025\u0073\u0027",_geb );
return &_geb ,_aebe ;}else if _cbg [0]=='('{_cd .Log .Trace ("\u002d>\u0053\u0074\u0072\u0069\u006e\u0067!");return _dcf .parseString ();}else if _cbg [0]=='['{_cd .Log .Trace ("\u002d\u003e\u0041\u0072\u0072\u0061\u0079\u0021");return _dcf .parseArray ();
}else if (_cbg [0]=='<')&&(_cbg [1]=='<'){_cd .Log .Trace ("\u002d>\u0044\u0069\u0063\u0074\u0021");return _dcf .parseDict ();}else if _cbg [0]=='<'{_cd .Log .Trace ("\u002d\u003e\u0048\u0065\u0078\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0021");return _dcf .parseHexString ();
}else if _cbg [0]=='%'{_dcf .readComment ();_dcf .skipSpaces ();}else {_cd .Log .Trace ("\u002d\u003eN\u0075\u006d\u0062e\u0072\u0020\u006f\u0072\u0020\u0072\u0065\u0066\u003f");_cbg ,_ =_dcf ._bfb .Peek (15);_ece :=string (_cbg );_cd .Log .Trace ("\u0050\u0065\u0065k\u0020\u0073\u0074\u0072\u003a\u0020\u0025\u0073",_ece );
if (len (_ece )> 3)&&(_ece [:4]=="\u006e\u0075\u006c\u006c"){_gce ,_cbgc :=_dcf .parseNull ();return &_gce ,_cbgc ;}else if (len (_ece )> 4)&&(_ece [:5]=="\u0066\u0061\u006cs\u0065"){_ebb ,_bccg :=_dcf .parseBool ();return &_ebb ,_bccg ;}else if (len (_ece )> 3)&&(_ece [:4]=="\u0074\u0072\u0075\u0065"){_cef ,_bdea :=_dcf .parseBool ();
return &_cef ,_bdea ;};_daf :=_bfa .FindStringSubmatch (_ece );if len (_daf )> 1{_cbg ,_ =_dcf ._bfb .ReadBytes ('R');_cd .Log .Trace ("\u002d\u003e\u0020\u0021\u0052\u0065\u0066\u003a\u0020\u0027\u0025\u0073\u0027",string (_cbg [:]));_gafb ,_eaab :=_gac (string (_cbg ));
return &_gafb ,_eaab ;};_abf :=_dba .FindStringSubmatch (_ece );if len (_abf )> 1{_cd .Log .Trace ("\u002d\u003e\u0020\u004e\u0075\u006d\u0062\u0065\u0072\u0021");return _dcf .parseNumber ();};_abf =_ffc .FindStringSubmatch (_ece );if len (_abf )> 1{_cd .Log .Trace ("\u002d\u003e\u0020\u0045xp\u006f\u006e\u0065\u006e\u0074\u0069\u0061\u006c\u0020\u004e\u0075\u006d\u0062\u0065r\u0021");
_cd .Log .Trace ("\u0025\u0020\u0073",_abf );return _dcf .parseNumber ();};_cd .Log .Debug ("\u0045R\u0052\u004f\u0052\u0020U\u006e\u006b\u006e\u006f\u0077n\u0020(\u0070e\u0065\u006b\u0020\u0022\u0025\u0073\u0022)",_ece );return nil ,_fb .New ("\u006f\u0062\u006a\u0065\u0063t\u0020\u0070\u0061\u0072\u0073\u0069\u006e\u0067\u0020\u0065\u0072\u0072\u006fr\u0020\u002d\u0020\u0075\u006e\u0065\u0078\u0070\u0065\u0063\u0074\u0065\u0064\u0020\u0070\u0061\u0074\u0074\u0065\u0072\u006e");
};};};func (_fbc *fdfParser )parseNumber ()(_cb .PdfObject ,error ){return _cb .ParseNumber (_fbc ._bfb )};func (_gec *fdfParser )parseBool ()(_cb .PdfObjectBool ,error ){_fcf ,_adc :=_gec ._bfb .Peek (4);if _adc !=nil {return _cb .PdfObjectBool (false ),_adc ;
};if (len (_fcf )>=4)&&(string (_fcf [:4])=="\u0074\u0072\u0075\u0065"){_gec ._bfb .Discard (4);return _cb .PdfObjectBool (true ),nil ;};_fcf ,_adc =_gec ._bfb .Peek (5);if _adc !=nil {return _cb .PdfObjectBool (false ),_adc ;};if (len (_fcf )>=5)&&(string (_fcf [:5])=="\u0066\u0061\u006cs\u0065"){_gec ._bfb .Discard (5);
return _cb .PdfObjectBool (false ),nil ;};return _cb .PdfObjectBool (false ),_fb .New ("\u0075n\u0065\u0078\u0070\u0065c\u0074\u0065\u0064\u0020\u0062o\u006fl\u0065a\u006e\u0020\u0073\u0074\u0072\u0069\u006eg");};func (_dbc *fdfParser )parseArray ()(*_cb .PdfObjectArray ,error ){_caa :=_cb .MakeArray ();
_dbc ._bfb .ReadByte ();for {_dbc .skipSpaces ();_cbc ,_gbc :=_dbc ._bfb .Peek (1);if _gbc !=nil {return _caa ,_gbc ;};if _cbc [0]==']'{_dbc ._bfb .ReadByte ();break ;};_dgd ,_gbc :=_dbc .parseObject ();if _gbc !=nil {return _caa ,_gbc ;};_caa .Append (_dgd );
};return _caa ,nil ;};type fdfParser struct{_gba int ;_agd int ;_cdeg map[int64 ]_cb .PdfObject ;_bbe _fef .ReadSeeker ;_bfb *_bb .Reader ;_dg int64 ;_ec *_cb .PdfObjectDictionary ;};func (_bge *fdfParser )parseString ()(*_cb .PdfObjectString ,error ){_bge ._bfb .ReadByte ();
var _ad _bcg .Buffer ;_cbfa :=1;for {_cbb ,_fde :=_bge ._bfb .Peek (1);if _fde !=nil {return _cb .MakeString (_ad .String ()),_fde ;};if _cbb [0]=='\\'{_bge ._bfb .ReadByte ();_gee ,_bed :=_bge ._bfb .ReadByte ();if _bed !=nil {return _cb .MakeString (_ad .String ()),_bed ;
};if _cb .IsOctalDigit (_gee ){_baa ,_afc :=_bge ._bfb .Peek (2);if _afc !=nil {return _cb .MakeString (_ad .String ()),_afc ;};var _dacg []byte ;_dacg =append (_dacg ,_gee );for _ ,_fa :=range _baa {if _cb .IsOctalDigit (_fa ){_dacg =append (_dacg ,_fa );
}else {break ;};};_bge ._bfb .Discard (len (_dacg )-1);_cd .Log .Trace ("\u004e\u0075\u006d\u0065ri\u0063\u0020\u0073\u0074\u0072\u0069\u006e\u0067\u0020\u0022\u0025\u0073\u0022",_dacg );_aff ,_afc :=_fe .ParseUint (string (_dacg ),8,32);if _afc !=nil {return _cb .MakeString (_ad .String ()),_afc ;
};_ad .WriteByte (byte (_aff ));continue ;};switch _gee {case 'n':_ad .WriteRune ('\n');case 'r':_ad .WriteRune ('\r');case 't':_ad .WriteRune ('\t');case 'b':_ad .WriteRune ('\b');case 'f':_ad .WriteRune ('\f');case '(':_ad .WriteRune ('(');case ')':_ad .WriteRune (')');
case '\\':_ad .WriteRune ('\\');};continue ;}else if _cbb [0]=='('{_cbfa ++;}else if _cbb [0]==')'{_cbfa --;if _cbfa ==0{_bge ._bfb .ReadByte ();break ;};};_ga ,_ :=_bge ._bfb .ReadByte ();_ad .WriteByte (_ga );};return _cb .MakeString (_ad .String ()),nil ;
};func (_gff *fdfParser )seekToEOFMarker (_bca int64 )error {_dbcb :=int64 (0);_cabd :=int64 (1000);for _dbcb < _bca {if _bca <=(_cabd +_dbcb ){_cabd =_bca -_dbcb ;};_ ,_ada :=_gff ._bbe .Seek (-_dbcb -_cabd ,_fef .SeekEnd );if _ada !=nil {return _ada ;
};_dfa :=make ([]byte ,_cabd );_gff ._bbe .Read (_dfa );_cd .Log .Trace ("\u004c\u006f\u006f\u006bi\u006e\u0067\u0020\u0066\u006f\u0072\u0020\u0045\u004f\u0046 \u006da\u0072\u006b\u0065\u0072\u003a\u0020\u0022%\u0073\u0022",string (_dfa ));_gfb :=_bbc .FindAllStringIndex (string (_dfa ),-1);
if _gfb !=nil {_fbd :=_gfb [len (_gfb )-1];_cd .Log .Trace ("\u0049\u006e\u0064\u003a\u0020\u0025\u0020\u0064",_gfb );_gff ._bbe .Seek (-_dbcb -_cabd +int64 (_fbd [0]),_fef .SeekEnd );return nil ;};_cd .Log .Debug ("\u0057\u0061\u0072\u006e\u0069\u006eg\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006b\u0065\u0072\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075n\u0064\u0021\u0020\u002d\u0020\u0063\u006f\u006e\u0074\u0069\u006e\u0075\u0065\u0020s\u0065e\u006b\u0069\u006e\u0067");
_dbcb +=_cabd ;};_cd .Log .Debug ("\u0045\u0072\u0072\u006f\u0072\u003a\u0020\u0045\u004f\u0046\u0020\u006d\u0061\u0072\u006be\u0072 \u0077\u0061\u0073\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064\u002e");return _fb .New ("\u0045\u004f\u0046\u0020\u006e\u006f\u0074\u0020\u0066\u006f\u0075\u006e\u0064");
};var _ffc =_b .MustCompile ("\u005e\u005b\u005c+-\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e]\u002b)\u0065[\u005c+\u002d\u002e\u005d\u002a\u0028\u005b\u0030\u002d\u0039\u002e\u005d\u002b\u0029");func (_ae *fdfParser )readAtLeast (_dfe []byte ,_fc int )(int ,error ){_aag :=_fc ;
_fd :=0;_ede :=0;for _aag > 0{_dac ,_abc :=_ae ._bfb .Read (_dfe [_fd :]);if _abc !=nil {_cd .Log .Debug ("\u0045\u0052\u0052O\u0052\u0020\u0046\u0061i\u006c\u0065\u0064\u0020\u0072\u0065\u0061d\u0069\u006e\u0067\u0020\u0028\u0025\u0064\u003b\u0025\u0064\u0029\u0020\u0025\u0073",_dac ,_ede ,_abc .Error ());
return _fd ,_fb .New ("\u0066\u0061\u0069\u006c\u0065\u0064\u0020\u0072\u0065a\u0064\u0069\u006e\u0067");};_ede ++;_fd +=_dac ;_aag -=_dac ;};return _fd ,nil ;};func (_bfac *fdfParser )parse ()error {_bfac ._bbe .Seek (0,_fef .SeekStart );_bfac ._bfb =_bb .NewReader (_bfac ._bbe );
for {_bfac .skipComments ();_afa ,_abff :=_bfac ._bfb .Peek (20);if _abff !=nil {_cd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020\u0046\u0061\u0069\u006c\u0020\u0074\u006f\u0020r\u0065a\u0064\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a");
return _abff ;};if _c .HasPrefix (string (_afa ),"\u0074r\u0061\u0069\u006c\u0065\u0072"){_bfac ._bfb .Discard (7);_bfac .skipSpaces ();_bfac .skipComments ();_fab ,_ :=_bfac .parseDict ();_bfac ._ec =_fab ;break ;};_afbg :=_gbb .FindStringSubmatchIndex (string (_afa ));
if len (_afbg )< 6{_cd .Log .Debug ("\u0045\u0052\u0052\u004f\u0052\u003a\u0020U\u006e\u0061\u0062l\u0065\u0020\u0074\u006f \u0066\u0069\u006e\u0064\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020\u0073\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065\u0020\u0028\u0025\u0073\u0029",string (_afa ));
return _fb .New ("\u0075\u006e\u0061b\u006c\u0065\u0020\u0074\u006f\u0020\u0064\u0065\u0074\u0065\u0063\u0074\u0020\u0069\u006e\u0064\u0069\u0072\u0065\u0063\u0074\u0020\u006f\u0062\u006a\u0065\u0063\u0074\u0020s\u0069\u0067\u006e\u0061\u0074\u0075\u0072\u0065");
};_fea ,_abff :=_bfac .parseIndirectObject ();if _abff !=nil {return _abff ;};switch _egd :=_fea .(type ){case *_cb .PdfIndirectObject :_bfac ._cdeg [_egd .ObjectNumber ]=_egd ;case *_cb .PdfObjectStream :_bfac ._cdeg [_egd .ObjectNumber ]=_egd ;default:return _fb .New ("\u0074\u0079\u0070\u0065\u0020\u0065\u0072\u0072\u006f\u0072");
};};return nil ;};